;;;;;;;;;;;;;;;;;;;;;;; Qstamp.LSP ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;;;   (C) Copyright 1993 by Leonard R. Miller.
;;;       Rt 4 Box 183b, Camden, Ar, 71701
;;;       74216.2346@compuserve.com
;;;       lmiller@infogo.com
;;;
;;;   I provide this program "as is" and with all faults.  I do not
;;;   warrant its operation to be error free.
;;;
;;; Permission to use, copy, modify, and distribute this software
;;; for any non-commerial, non-profit purpose and without fee is
;;; hereby granted, provided that the above copyright notice appears
;;; in all copies and that both the above copyright notice and this
;;; permission notice also appear in all supporting documentation.
;;;
;
; For those quickie, "to fit", hard copies - the ones which often
; exclude the title block and other identifying info.  It places
; normally neglected information where it's visible all the time.
; Vitals such as drawing name, source directory, date and time,
; even a calculated scale reference.  Qstamp will appear, correctly
; sized, in upper left corner of drawing, poised for you to drag
; to any vacant space. Qstamp is created on a unique layer so a
; ssget routine (see below) can easily find it later for automatic
; purging. Default scale units is "inches".  In our work I set
; a global variable US_MM to either 1.0 (for inches) or 25.4 (for
; metric).
;
; My menu macro for saving drawings is on the next 3 lines and
; illustrates the purging of the "Qstamp" entities, then the save.
;;; ^C^C(setq trash_stamp (ssget "x" '((8 . "donotuse_me"))))+
;;; (if (/= trash_stamp nil)(command "erase" trash_stamp ""))+
;;; (command "save")
;
;-------------- Modify, Jan 96 ---------------------------
; Some users report first version not working following December, 1996
; issue of Cadalyst, Hot Tip Harry column. For one thing 
; program used "exp" an AutoCAD function, as global var to store
; value of the EXPERT system variable. Change that along with all other
; global variables (with exception of US_MM) to local vars. This should
; reduce liklihood they'll be stepped on by other applications running.
;
(defun c:Qstamp (/
 apr ce col dat dname xprt grd hourz hour_min incr lyr minit opt_sz
 osn oto path pbx plw rgm scale_lgth scale_pt scale_pt1 scale_pt2 scale_pt3
 scale_pt4 scale_pt5 scale_pt6 snp the_date tlm tx1 tx2 txe txs txt_pt
 unitz view_ctr view_size
)
;;
;;
(setq pbx (getvar "pickbox") lyr (getvar "clayer")
  ce (getvar "cmdecho") col (getvar "cecolor") osn (getvar "osmode")
  snp (getvar "snapmode") grd (getvar "gridmode") oto (getvar "orthomode")
  plw (getvar "plinewid") txe (getvar "texteval") txs (getvar "textstyle")
  tlm (getvar "tilemode") xprt (getvar "expert") rgm (getvar "regenmode")
  apr (getvar "aperture")
)
;;
;;
(command "layer" "s" "0" "")
(command "pickbox" "0")
(command "color" "bylayer")
(command "style" "stmp" "" "0" "" "" "" "" "")
(setvar "plinewid" 0)
(setvar "gridmode" 0)
(setvar "expert" 1)
(setvar "regenmode" 0)
(setvar "snapmode" 0)
(setvar "aperture" 1)
(setvar "osmode" 0)
(setvar "cmdecho" 0)
(setvar "orthomode" 0)
(setvar "texteval" 0)
(setvar "tilemode" 1)
(setq view_ctr (getvar "viewctr"))
(setq view_size (getvar "viewsize"))
(setq opt_sz (/ view_size 14.0))
(setq incr 0.000488281)
(while (< incr opt_sz)
 (setq scale_lgth incr)
 (setq incr (* incr 2.0))
);end while
;;;extract dwg portion only
(setq dname (dwgname8))
(setq path (getvar "dwgprefix"))
(setq tx1 (strcase (strcat "FILE NAME:  " dname)))
(setq tx2 (rtos (getvar "cdate") 2 0))
(setq the_date
 (strcat
  (substr tx2 5 2)"/"(substr tx2 7 2)"/"(substr tx2 3 2)))
(setq dat (atof (substr (rtos (getvar "date") 2 6) 8 5)))
(setq hour_min (* dat 24.0))
(setq hourz (fix hour_min))
(setq minit (* (- hour_min hourz) 60.0))
;add leading zero if needed
(setq minit (rtos minit 2 0))
(if (< (strlen minit) 2)
 (setq minit (strcat "0" minit))
)
(setq txt_pt (polar view_ctr pi (/ view_size 2.7)))
(setq txt_pt (polar txt_pt 90.0 (/ view_size 2.0)))
(setq scale_pt txt_pt)
(command "layer" "m" "donotuse_me" "c" "red" "" "")
(command "text" txt_pt (/ view_size 100.0) 0.0 tx1)
(command "text" "" (strcat "PRINTED: " (itoa hourz) ":"
   minit ", "
   (substr tx2 5 2) "/"
   (substr tx2 7 2) "/"
   (substr tx2 3 2)))
(if (= us_mm nil)
 (setq unitz " UNITS.")
 (if(= us_mm 25.4)
  (setq unitz " MM.")
  (setq unitz " INCHES.")
 )
)
(command "text" "" (strcat "PATH: " path"  SCALE INCR = "
 (rtos scale_lgth) unitz)) 
(setq scale_pt1 (polar scale_pt (* pi 1.5)(/ view_size 23.0)))
(setq scale_pt2 (polar scale_pt1 0.0 scale_lgth))
(setq scale_pt3 (polar scale_pt2 0.0 scale_lgth))
(setq scale_pt4 (polar scale_pt3 0.0 scale_lgth))
(setq scale_pt5 (polar scale_pt4 0.0 scale_lgth))
(setq scale_pt6 (polar scale_pt5 0.0 scale_lgth))
(command "pline" scale_pt1 "w" (/ view_size 100.0) "" scale_pt2 "")
(command "pline" scale_pt2 "w" 0.0 "" scale_pt3 "")
(command "pline" scale_pt3 "w" (/ view_size 100.0) "" scale_pt4 "")
(command "pline" scale_pt4 "w" 0.0 "" scale_pt5 "")
(command "pline" scale_pt5 "w" (/ view_size 100.0) "" scale_pt6 "")
(command "pline" scale_pt "w" 0.0 0.0 scale_pt "")
(command "erase" "l" "")
(ssget "x" '((8 . "donotuse_me")))
(command "move" "p" "" "@" pause)
;
;;
;;restore prior settings.
(command "layer" "s" lyr "")
(setvar "pickbox" pbx)
(setvar "cmdecho" ce)
(setvar "cecolor" col)
(setvar "osmode" osn)
(setvar "snapmode" snp)
(setvar "gridmode" grd)
(setvar "orthomode" oto)
(setvar "plinewid" plw)
(setvar "texteval" txe)
(setvar "textstyle" txs)
(setvar "tilemode" tlm)
(setvar "expert" xprt)
(setvar "regenmode" rgm)
(setvar "aperture" apr)
(princ)
)
;;
;;
;;;Fname.lsp, contr by Mark Middlebrook and created by Tony Tanzillo
;;; [and expertly typed (:>) by Len Miller, Dec 1993].
;;;  The following two routines were integrated because
;;;  of a (now) well-known ACAD "bug" where four circumstances
;;;  of checking "dwgname" yield incorrect results.  These
;;;  routines have corrected the problems I observed.
(defun file_nam (path_string)
 (if (wcmatch path_string "*\\*,*/*,*:*")
  (substr path_string (1+ (file_nam_aux (strlen path_string))))
  path_string
 )
)
(defun file_nam_aux (start_chr)
 (cond
  ((zerop start_chr) 0)
  ((member (substr path_string start_chr 1) '("\\" "/" ":")) start_chr)
  (t (file_nam_aux (1- start_chr))))
)
(defun dwgname8 ()
 (file_nam (getvar"dwgname"))
)
;;; end Qstamp.LSP ;;;;;;;;;;;